<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>System Structure and Parameterization (SSP) &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../_static/doctools.js?v=888ff710"></script>
        <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="World_OSI" href="world_osi.html" />
    <link rel="prev" title="Spawner Features" href="spawner_features.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            openPASS
              <img src="../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../20_simulator_advanced.html">Simulator</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="agent_components.html">Agent Components</a></li>
<li class="toctree-l2"><a class="reference internal" href="coordinate_systems.html">Coordinate Systems</a></li>
<li class="toctree-l2"><a class="reference internal" href="event_detector.html">EventDetector</a></li>
<li class="toctree-l2"><a class="reference internal" href="scenario_actions.html">Mapping of OpenSCENARIO Actions</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulation.html">Simulation</a></li>
<li class="toctree-l2"><a class="reference internal" href="spawner_features.html">Spawner Features</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">System Structure and Parameterization (SSP)</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#inputs-ssp-structure">Inputs / SSP Structure</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#system-structure-package-ssp">System Structure Package SSP</a></li>
<li class="toctree-l4"><a class="reference internal" href="#ssd-system-structure-definition">SSD - System Structure Definition</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#implementation">Implementation</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#parsing">Parsing</a></li>
<li class="toctree-l4"><a class="reference internal" href="#osi-connectors">OSI Connectors</a></li>
<li class="toctree-l4"><a class="reference internal" href="#object-structure">Object Structure</a></li>
<li class="toctree-l4"><a class="reference internal" href="#ssp-and-op">SSP and <strong>openPASS</strong></a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#limits">Limits</a></li>
<li class="toctree-l3"><a class="reference internal" href="#outputs">Outputs</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#folderstructure">FolderStructure</a></li>
<li class="toctree-l4"><a class="reference internal" href="#writemessageparameters">WriteMessageParameters</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="world_osi.html">World_OSI</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../20_simulator_advanced.html">Simulator</a></li>
      <li class="breadcrumb-item active">System Structure and Parameterization (SSP)</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../_sources/advanced_topics/simulator/system_structure_and_parameterization_(SSP).rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="system-structure-and-parameterization-ssp">
<span id="ssp"></span><h1>System Structure and Parameterization (SSP)<a class="headerlink" href="#system-structure-and-parameterization-ssp" title="Link to this heading"></a></h1>
<p>System Structure and Parameterization (SSP) is a tool independent standard to define
complete systems consisting of one or more FMUs
(see Functional-Mockup-Interface [LINK: <a class="reference external" href="https://fmi-standard.org/">https://fmi-standard.org/</a>])
including its parameterization that can be transferred between simulation tools.
Official content is available under: <a class="reference external" href="https://ssp-standard.org/">https://ssp-standard.org/</a> .</p>
<p>In <strong>openPASS</strong> we use SSP to connect FMUs with each other,
especially those which need communication during one simulation time step.
The whole SSP is appended as vehicle component.</p>
<section id="inputs-ssp-structure">
<span id="ssp-input"></span><h2>Inputs / SSP Structure<a class="headerlink" href="#inputs-ssp-structure" title="Link to this heading"></a></h2>
<p>The following image displays the example ConnectionTest.ssp. This SSP contains one root SSD-System,
the subsystem OSMPConnectionTest and two SSD-Components, that are connected with each other.</p>
<figure class="align-default" id="osmpconnectiontest-visual">
<img alt="../../_images/%5BB2%5DOsmpConnectionTest_Visual.png" src="../../_images/%5BB2%5DOsmpConnectionTest_Visual.png" />
</figure>
<p>FMUs are wrapped within a SSD-Component. The example consists of two FMU’s “DummySensor” and “OSMPTrafficUpdateStepper”.
To allow these two to exchange data within one timestep, they need a connection, which consists of two connectors.
Either a connector gets data from outside of the SSP-System, for instance <strong>openPASS</strong>.
Or two connectors which are directly connected within the SSP-System.
These connections are only one directional.
The example shows a common usecase of SSP: A sensor Component transfers SensorData to the TrafficUpdateStepper,
which writes a DynamicSignal. This signal leaves this SSP to animate the agent.</p>
<section id="system-structure-package-ssp">
<h3>System Structure Package SSP<a class="headerlink" href="#system-structure-package-ssp" title="Link to this heading"></a></h3>
<p>On the filesystem, a SSP is a zip file, which includes one or more .ssd files together with related resources.</p>
<p>In our example the unpacked zip looks like this:</p>
<blockquote>
<div><div class="highlight-default notranslate"><div class="highlight"><pre><span></span>..\ConnectionTest.ssp
├── SystemStructure.ssd (mandatory !)
├── OSMPConnectionTest.ssd
├── ParameterValues.ssv
├── Resources
│  ├── DummySensor.fmu
│  └── OsmpTrafficUpdateStepper.fmu
</pre></div>
</div>
<p>In the folder structure above:</p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">SystemStructure.ssd</span></code> can be perceived as the root of the SSP. It contains the root system.</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">OSMPConnectionTest.ssd</span></code> A system within the root system</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">ParameterValues.ssv</span></code> Alternative way to describe the values of SSP parameters (<a class="reference internal" href="#ssvfiles"><span class="std std-ref">ref</span></a>)</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Resources</span></code> The Resources folder is for additional data, like FMUs.</p></li>
</ul>
</div></blockquote>
<p>Resources can be referenced FMUs.
Any SSP specific files should be located in the zip root directory.
SSP files are referenced from the System Structure Description file(s) through relative URIs (cf. RFC 3986).
SystemStructure.ssd is the root file of the zip archive. System structure definitions (*.ssd) describe entities called Systems.
Additional entries may include Parameter Values (*.ssv), Parameter Mappings (*.ssm) or Signal Dictionaries (*.ssb).</p>
<p><strong>System Structure description (.ssd files)</strong></p>
<p>The file “SystemStructure.ssd” is mandatory because it defines to root of the SSP.
Other (*).ssd can be used to make use of more then one system, or for organisation purpose.
Subsystems that are hierarchically within the root system should be listed in that SSD.
Subsystems which are only present as (*).ssd but are not connected with the root. More on that in section <a class="reference internal" href="#ssd"><span class="std std-ref">SSD - System Structure Definition</span></a>.</p>
<p id="ssvfiles"><strong>System Structure Parameter Values (.ssv files)</strong></p>
<p>Not mandatory. Is supported in the current version of <strong>openPASS</strong>.
Parameter Values describes a collection of ssd:ParameterSet
A ParameterSet is a collection of parameters grouped under a name.
Parameter Values can be added in two ways:</p>
<ol class="arabic simple">
<li><p>directly define it within the .ssd file in ssd:ParameterValues</p></li>
<li><p>create a .ssv file and reference it within the .ssd under ssd:ParameterValues</p></li>
</ol>
<p><strong>System Structure Parameter Mapping (.ssm files)</strong></p>
<p>Not mandatory. Not yet implemented in current <strong>openPASS</strong> version.
A parameter mapping describes a mapping between parameters.
A parameter mapping can be added in two ways:</p>
<ol class="arabic simple">
<li><p>directly define it within the .ssd file in one ssd:ParameterMapping</p></li>
<li><p>create a .ssm file and reference it within the .ssd in one ssd:ParameterMappings</p></li>
</ol>
<p><strong>System Structure Signal Dictionaries (.ssb files)</strong></p>
<p>Is not mandatory. Not yet implemented in current <strong>openPASS</strong> version.
A signal dictionary is a collection of signals.
There are two ways to define a signal dictionary:</p>
<ol class="arabic simple">
<li><p>directly define it within the .ssd file in ssd:ParameterMappings</p></li>
<li><p>create a .ssb file and reference it within the .ssd in ssd:ParameterMappings</p></li>
</ol>
</section>
<section id="ssd-system-structure-definition">
<span id="ssd"></span><h3>SSD - System Structure Definition<a class="headerlink" href="#ssd-system-structure-definition" title="Link to this heading"></a></h3>
<p>The following example shows the definition of a system “OSMPConnectionTest”.</p>
<figure class="align-default" id="id1">
<span id="osmpconnectiontest-schema"></span><img alt="../../_images/OsmpConnectionTest.ssd_Schemaansicht.png" src="../../_images/OsmpConnectionTest.ssd_Schemaansicht.png" />
<figcaption>
<p><span class="caption-text">Schematic representation of OSMPConnection.ssd</span><a class="headerlink" href="#id1" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>In the root System, OSMPConnectionTest is defined as an Element.
So this System is a subsystem of the root System.
The file “OSMPConnectionTest.ssd” defines the subsystem, which consists of two Components “DummySensor” and “TrafficUpdateStepper”.
Notice, how Components are listed as Elements. In general, Elements of a System can either be a System or a Component.
You can think of it as a filestructure, in our example we keep it simple with just two Components in the Elements of OSMPConnectionTest.</p>
<p><strong>In General</strong></p>
<p>Each System consists of zero to many Elements and zero to many Connections
A Element can either be a Component, a SignalDictionaryReference or a System (Subsystem).
Each Element can have zero to many connectors, which are used to define Connections.
Connectors can interface with the FMU model description.
A Connector has a certain type (data type), and can have zero two many Annotations
An Annotation is used to give additional information for any model entity, which we are using in <strong>openPASS</strong> to make OSMPConnectors (see <a class="reference internal" href="#ssp-osmpconnector"><span class="std std-ref">OSI Connectors</span></a>)
Furthermore each Element has zero to many ParameterBindings.
The parametrization of the FMUs is handled with a ParameterSet.</p>
<p><strong>OSMP Connectors</strong></p>
<p>By using an Annotation, we can combine three Connectors to be able to handle OSI messages. Notice, that Annotations
are a valid way to extend the standard with features, which are not part of SSP yet.</p>
<blockquote>
<div><div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">                        </span><span class="nt">&lt;ssd:Annotations&gt;</span>
<span class="w">                            </span><span class="nt">&lt;ssc:Annotation</span><span class="w"> </span><span class="na">type=</span><span class="s">&quot;net.pmsf.osmp&quot;</span><span class="nt">&gt;</span>
<span class="w">                                </span><span class="nt">&lt;osmp:osmp-binary-variable</span>
<span class="w">                                        </span><span class="na">xmlns:osmp=</span><span class="s">&quot;http://xsd.pmsf.net/OSISensorModelPackaging&quot;</span>
<span class="w">                                        </span><span class="na">mime-type=</span><span class="s">&quot;application/x-open-simulation-interface; type=SensorData; version=3.2.1&quot;</span>
<span class="w">                                        </span><span class="na">name=</span><span class="s">&quot;OSMPSensorDataOut&quot;</span>
<span class="w">                                        </span><span class="na">role=</span><span class="s">&quot;size&quot;</span><span class="nt">/&gt;</span>
<span class="w">                            </span><span class="nt">&lt;/ssc:Annotation&gt;</span>
<span class="w">                        </span><span class="nt">&lt;/ssd:Annotations&gt;</span>
</pre></div>
</div>
</div></blockquote>
<p>Three Connectors combine with an Annotation of type “net.psmf.osmp”, by having the same name inside the osmp:osmp-binary-variable.
osmp:osmp-binary-variable comes always in the same shape.
Each triple of connectors must have the three following roles: base.lo, base.hi and size.
base.lo and base.hi make a memory pointer, where the OSI message is allocated during simulation.
size contains the memory size of the message. In combination of the three connectors the message can be passed between components
Also, notice how mime-type contains crucial information. Type specifies the type of the OSI message. Version is specified as well.</p>
<p><strong>FMU Parameters</strong></p>
<p>The FMU inside the ssd component needs parametrization as well. These are the same parameters as the parameters of the Algorithm_FmuWrapper.
To parametrize the FMU inside ssd, we define a ParameterSet inside the ParameterBindings. Important is the name attribute of the ParameterSet (name=”FMUParameters”):</p>
<blockquote>
<div><div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">                            </span><span class="nt">&lt;ssv:ParameterSet</span><span class="w"> </span><span class="na">version=</span><span class="s">&quot;1.0&quot;</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;FmuParameters&quot;</span><span class="nt">&gt;</span>
<span class="w">                                </span><span class="nt">&lt;ssv:Parameters&gt;</span>
<span class="w">                                    </span><span class="nt">&lt;ssv:Parameter</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;Logging&quot;</span><span class="nt">&gt;</span>
<span class="w">                                        </span><span class="nt">&lt;ssv:Boolean</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;true&quot;</span><span class="nt">/&gt;</span>
<span class="w">                                    </span><span class="nt">&lt;/ssv:Parameter&gt;</span>
<span class="w">                                    </span><span class="nt">&lt;ssv:Parameter</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;CsvOutput&quot;</span><span class="nt">&gt;</span>
<span class="w">                                        </span><span class="nt">&lt;ssv:Boolean</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;true&quot;</span><span class="nt">/&gt;</span>
<span class="w">                                    </span><span class="nt">&lt;/ssv:Parameter&gt;</span>
<span class="w">                                    </span><span class="nt">&lt;ssv:Parameter</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;UnzipOncePerInstance&quot;</span><span class="nt">&gt;</span>
<span class="w">                                        </span><span class="nt">&lt;ssv:Boolean</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;false&quot;</span><span class="nt">/&gt;</span>
<span class="w">                                    </span><span class="nt">&lt;/ssv:Parameter&gt;</span>
<span class="w">                                    </span><span class="nt">&lt;ssv:Parameter</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;WriteJson_SensorView&quot;</span><span class="nt">&gt;</span>
<span class="w">                                        </span><span class="nt">&lt;ssv:Boolean</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;true&quot;</span><span class="nt">/&gt;</span>
<span class="w">                                    </span><span class="nt">&lt;/ssv:Parameter&gt;</span>
<span class="w">									</span><span class="nt">&lt;ssv:Parameter</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;WriteTrace_SensorView&quot;</span><span class="nt">&gt;</span>
<span class="w">                                        </span><span class="nt">&lt;ssv:Boolean</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;true&quot;</span><span class="nt">/&gt;</span>
<span class="w">                                    </span><span class="nt">&lt;/ssv:Parameter&gt;</span>
<span class="w">                                    </span><span class="nt">&lt;ssv:Parameter</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;Input_OSMPSensorViewIn&quot;</span><span class="nt">&gt;</span>
<span class="w">                                        </span><span class="nt">&lt;ssv:String</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;SensorView&quot;</span><span class="nt">/&gt;</span>
<span class="w">                                    </span><span class="nt">&lt;/ssv:Parameter&gt;</span>
<span class="w">                                </span><span class="nt">&lt;/ssv:Parameters&gt;</span>
<span class="w">                            </span><span class="nt">&lt;/ssv:ParameterSet&gt;</span>
</pre></div>
</div>
</div></blockquote>
<p>Each ssv::parameter has a sub object of the parameter type, with the attribute value containing the actual value.
SSP support the following types: Real (float value), Integer, Boolean, String, Enumeration and Binary.</p>
<p><strong>PriorityParameter</strong>
The priority of the component is set through an annotation on component level
With a higher priority, a FMU component triggers earlier then others.</p>
<blockquote>
<div><div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">                    </span><span class="nt">&lt;ssc:Annotation</span><span class="w"> </span><span class="na">type=</span><span class="s">&quot;de.setlevel.ssp.scheduling&quot;</span><span class="nt">&gt;</span>
<span class="w">                        </span><span class="cm">&lt;!--Standard priority is 0. Same prio is schduled parallel--&gt;</span>
<span class="w">                        </span><span class="nt">&lt;slex:co-simulation</span>
<span class="w">                            </span><span class="na">priority=</span><span class="s">&quot;42&quot;</span><span class="nt">/&gt;</span>
<span class="w">                    </span><span class="nt">&lt;/ssc:Annotation&gt;</span>
</pre></div>
</div>
</div></blockquote>
</section>
</section>
<section id="implementation">
<span id="ssp-implementation"></span><h2>Implementation<a class="headerlink" href="#implementation" title="Link to this heading"></a></h2>
<section id="parsing">
<h3>Parsing<a class="headerlink" href="#parsing" title="Link to this heading"></a></h3>
<p>The first implementation detail of Algorithm SSP Wrapper, a selected SSP is loaded as vehicle component.
The following picture illustrates how files are parsed and interpreted in Algorithm_SspWrapper.</p>
<figure class="align-default" id="ssp-parsing">
<img alt="../../_images/%5BI1%5DParsing.png" src="../../_images/%5BI1%5DParsing.png" />
</figure>
<p>Algorithm_SspWrapper is initialized by parsing one .ssp. The zip folded contents of the .ssp is unpacked to a temporary folder
and the contents are scanned for ssd files, such as the mandatory “SystemStructure.ssd”.
The System described by “SystemStructure.ssd” makes the root system,
any other fully parsed system is included as subsystem of that root system.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>One parsed ssd. System includes GroupConnectors, which contain all outer accessible connectors.
A Connector is only visible from outside if it is connected with a connection. More on that in section <a class="reference internal" href="#ssp-objectstructure"><span class="std std-ref">Object Structure</span></a></p>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Should there be systems which are described by .ssd files, they must be in the elements array of the root system,
or in any other system related to the root system. Is a .ssd not in any relation to the root, it is ignored!</p>
</div>
<p>The process of interpreting the connections is part of the system creation.
Another feature of system creation is the formation of OSI Connectors we discuss in the next chapter:</p>
</section>
<section id="osi-connectors">
<span id="ssp-osmpconnector"></span><h3>OSI Connectors<a class="headerlink" href="#osi-connectors" title="Link to this heading"></a></h3>
<p>The next figure describes how triples of connectors form a OSI Connector.</p>
<figure class="align-default">
<img alt="../../_images/%5BI2%5DOsmpConnector.png" src="../../_images/%5BI2%5DOsmpConnector.png" />
</figure>
<p>OSI connectors come in triples since OSI messages are represented with 3 integers.
The integers base.lo and base.hi specify the memory location of the OSI message. base.size describes the buffer length.
Through the osmp annotation, a triple of connectors are joined together.
In the figures of this documentation, OSI Connectors are signaled by the purple color.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>The name attribute in the annotation joins the triple, whereas the connector name is relevant for the ssd system.</p>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>To connect OSI connectors, they require 3 connections in the .ssd. Once the file is parsed,
the 3 connections forms a complete connection in the system.</p>
</div>
<p>OSI connectors are responsible for writing messages. Should the OSI message of a OSI connector change,
and the connector parametrized to write output, it writes the new message as soon as it changes.
While json messages can be written to file directly, binary traces contain the serialized messages of much timesteps in one file.
Because of that, osi messages append binary traces to message containers in their SSP system. It’s contents are written
to file as soon the system destructs.</p>
</section>
<section id="object-structure">
<span id="ssp-objectstructure"></span><h3>Object Structure<a class="headerlink" href="#object-structure" title="Link to this heading"></a></h3>
<p>The implementation of SSP follows the relation of objects which the standard imposes.
Mainly the SSP contains at least one System. Each System contains Elements and Connectors.
Since Systems are Elements, Systems can include other Systems as subelements.</p>
<p>Another type of Elements are Components. One common used Component is the FMUComponent.
It is good practice that FMUComponents don’t contain further subelements.</p>
<p>The System originating from the mandatory SystemStructure.ssd makes the root System object,
containing all of it’s subsystems.</p>
<p>The Following picture shows ConnectionTest.ssp with two connected FMU’s.</p>
<figure class="align-default" id="ssp-connectiontestdetail">
<img alt="../../_images/%5BI3%5DOSMPConnectionTestDetail.png" src="../../_images/%5BI3%5DOSMPConnectionTestDetail.png" />
</figure>
<p>After parsing, Algorithm_SspWrapper holds only one SSP System, which is the root System defined by the systemstructure.ssd
In our example, we have one subsystem: OSMPConnection, which is a Element of the root System.
Within the Elements of the System OSMPConnection are two components, which are of the type FMUComponent.
Each of these Components hold an instance of Algorithm_FmuWrapper.
The two FMUs are connected by two OSI Connectors. To establish a connection, the following requirements need to be fulfilled:</p>
<ul class="simple">
<li><p>SensorDataOut has to be a OSI connector (see section <a class="reference internal" href="#ssp-osmpconnector"><span class="std std-ref">OSI Connectors</span></a>)</p></li>
<li><p>SensorDataOut should be an output connector of SensorDummy and SensorDataIn should be an input connector of TrafficUpdateStepper. Their kind is specified as a connector attribute in the ssd file.</p></li>
<li><p>both connectors are connected by the connection depicted with ‘*’ in the figure.</p></li>
</ul>
<p>The OSI connector SensorDataOut will propagate its SensorData to the other connector SensorDataIn.
Each System can have connections, which can connect connectors of two different elements.
Hence, each Connection is just a tuple of : (elementStartName, startConnectorName) -&gt; (elementEndName, endConnectorName)</p>
<blockquote>
<div><div class="admonition note">
<p class="admonition-title">Note</p>
<p>While OSI Connectors are abstracted as singular units in the figure, they appear as triple in the ssd. files.
Hence they require three connections in the ssd. file as well</p>
</div>
</div></blockquote>
<dl>
<dt>Example Connection between two components within the SSP (Connection ‘*’)</dt><dd><div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">            </span><span class="cm">&lt;!-- DummySensor &lt;-&gt; TrafficStepper --&gt;</span>
<span class="w">		    </span><span class="nt">&lt;ssd:Connection</span><span class="w"> </span><span class="na">startElement=</span><span class="s">&quot;DummySensor&quot;</span>
<span class="w">                            </span><span class="na">startConnector=</span><span class="s">&quot;SensorDataOut.size&quot;</span>
<span class="w">                            </span><span class="na">endElement=</span><span class="s">&quot;TrafficStepper&quot;</span>
<span class="w">                            </span><span class="na">endConnector=</span><span class="s">&quot;SensorDataIn.size&quot;</span>
<span class="w">                            </span><span class="na">suppressUnitConversion=</span><span class="s">&quot;false&quot;</span><span class="nt">/&gt;</span>
</pre></div>
</div>
</dd>
<dt>Example Connection from outside the system(e.g. openPASS or another system) to a component in the system (Connection ‘**’)</dt><dd><div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">            </span><span class="cm">&lt;!-- System &lt;-&gt; TrafficStepper --&gt;</span>
<span class="w">            </span><span class="nt">&lt;ssd:Connection</span><span class="w"> </span><span class="na">startElement=</span><span class="s">&quot;TrafficStepper&quot;</span>
<span class="w">                            </span><span class="na">startConnector=</span><span class="s">&quot;TrafficUpdateOut.size&quot;</span>
<span class="w">                            </span><span class="na">endConnector=</span><span class="s">&quot;TrafficUpdateOut.size&quot;</span>
<span class="w">                            </span><span class="na">suppressUnitConversion=</span><span class="s">&quot;false&quot;</span><span class="nt">/&gt;</span>
</pre></div>
</div>
</dd>
</dl>
<p id="ssp-connections">Notice that the connectors SensorDataIn, SensorDataOut and TrafficUpdate belong to their Components.
In the case of OSMPConnection, we are interested in the TrafficUpdate OSI message as output of the whole SSP.
Therefore, it needs a connection outwards.
This connection is represented by the connection ‘**’ in the figure. As you can see in the figure above, the second connection
connects connector TrafficUpdateOut with the GroupConnector systemOutput. To make the connection work, the following is necessary:
- TrafficUpdateOut has to be a OSI connector (see section <a class="reference internal" href="#ssp-osmpconnector"><span class="std std-ref">OSI Connectors</span></a>)
- TrafficUpdateOut should be an output connector of TrafficUpdate and there must be three output connectors at the system OSMPConnection. These mirror the names of the three connectors forming the OSI connector on TrafficUpdateStepper.
- Both connectors are connected by a connection depicted with ** in the figure.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>For the connectors of system level, the most minimal connectors are necessary.
These only require the attribute name that mirrors the name of the connectors forming the OSI Connector.</p>
</div>
<p>If all conditions are met, the output connector is emplaced in the GroupConnector systemOutput.
In this example there are no input connectors which are accessible form outside.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Again TrafficUpdateOut makes up a pair of three connectors in the .ssd files. Notice that, if connectors inside sub elements
are only accessible from outside by well defined connections.</p>
</div>
<p>Let’s see how these outside accessible connectors are utilized by <strong>openPASS</strong> in the next section.</p>
</section>
<section id="ssp-and-op">
<h3>SSP and <strong>openPASS</strong><a class="headerlink" href="#ssp-and-op" title="Link to this heading"></a></h3>
<p>From <strong>openPASS</strong>, the Algorithm SspWrapper receives three events: UpdateInput, UpdateOutput and Trigger.
For each of these events, the SSP Wrapper implementation handles them by creating Visitors following the Visitor software pattern.
These Visitors visiting Elements, and allow the Elements to implement the behaviour for each visitor based on if the element is a System or a Component.</p>
<p>In general, we have two types of Visitors: ConnectorVisitors and ElementVisitors.
In the following figure, you can see how the Visitors traverse through our OSMPConnectionExample</p>
<figure class="align-default" id="id2">
<span id="ssp-connectiontestdetailwithopenpass"></span><img alt="../../_images/%5BI4%5DOSMPConnectionTestDetailwithOpenPass.png" src="../../_images/%5BI4%5DOSMPConnectionTestDetailwithOpenPass.png" />
<figcaption>
<p><span class="caption-text">Components and channel communication</span><a class="headerlink" href="#id2" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>Trigger is an event that manifests as ElementVisitor in the Algorithm SSP Wrapper.
Each Element in the root System is visited by the TriggerVisitor. A system accepts the Visitor by passing it to further subsystems
and by creating a queue of FMUComponents that are stored inside the system’s elements array.
Each component has a priority which is used to order the queue.
Then, the queue is processed and Trigger is called on the Algorithm_FmuWrapper instances which are stored inside the FMUComponents.
After each Trigger, all output Connectors are visited by the PropagateDataVisitor, which propagates OSI messages from one Connector to the next.</p>
<p>UpdateInput and UpdateOutput are ConnectorVisitors. For each System in the root system, they visit the SystemConnectors
systemInput and systemOutput. GroupConnectors can be connected to other connectors (see <a class="reference internal" href="#ssp-connections"><span class="std std-ref">SSP Connections</span></a>).
Their job is to delegate ConnectorVisitors to their connected counterparts.
The UpdateInputVisitor and UpdateOutputVisitor follow the GroupConnectors systemInput/systemOutput down to it’s OSI Connectors.
Once these Visitors visit a OSIConnector, they can perform UpdateInput and UpdateOutput, if the OSI Connector is a connector of a FMUComponent.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>UpdateInput and UpdateOutput handling is still experimental. Since we need to decide to continue in calling UpdateInput/UpdateOutput on the FMU,
or to refactor OSMPFmuHandler.</p>
</div>
<p>At the beginning of the simulation, the Init Visitor is a unique ElementVisitor, which will traverse through the System and trigger on every FMU the init procedure.</p>
</section>
</section>
<section id="limits">
<span id="ssp-output"></span><h2>Limits<a class="headerlink" href="#limits" title="Link to this heading"></a></h2>
<p>The current implementation of SSP in the SSP Wrapper is not a full implementation of the SSP Standard
but rather a solution to connect more then one FMUs together.
Currently, these SSP features are not part of Algorithm SspWrapper :</p>
<ul class="simple">
<li><p>The standard allows usage of ids that can be used to refer any BaseElement in SSP</p></li>
<li><p>Other annotations besides OSMP Connectors and the component priority are ignored</p></li>
<li><p>Top Level meta data is not parsed</p></li>
<li><p>units and transformation between units are not supported</p></li>
<li><p>XML Element Choice : “Transformation Choice” as GType choice (for Connections) is not supported</p></li>
<li><p>SSP as component of Systems is not implemented</p></li>
<li><p>ParameterMapping (SSM) for automatic unit-mapping and name transformations in parameter binding is not implemented</p></li>
<li><p>Signal directories (SSB) as element of systems for cross hierarchical signal pools (e.g for buses) (and Signal Directory Reference) are not implemented</p></li>
<li><p>Default Experiment (with startTime and StopTime) is not used and ignored, the experiment control comes through <strong>openPASS</strong> events</p></li>
<li><p>Connectors of type string and binary data are not supported</p></li>
</ul>
</section>
<section id="outputs">
<h2>Outputs<a class="headerlink" href="#outputs" title="Link to this heading"></a></h2>
<p>For debugging purposes we allow to write out intermediate results during Simulation.</p>
<section id="folderstructure">
<h3>FolderStructure<a class="headerlink" href="#folderstructure" title="Link to this heading"></a></h3>
<p>The following folder structure shows the output files of our example.</p>
<blockquote>
<div><div class="highlight-default notranslate"><div class="highlight"><pre><span></span>..\results
├── ssp
│  ├── Agent0xxx
│  │   ├──OsmpConnectionTest
│  │   │   ├── DummySensor
│  │   │   │  ├── JsonFiles
│  │   │   │  └── BinaryTraceFiles
│  │   │   ├── TrafficUpdateStepper
│  │   │   │   ├── JsonFiles
│  │   │   │   └── BinaryTraceFiles
│  │   │   └──
│  │   └──
│  └──
└──
</pre></div>
</div>
</div></blockquote>
<dl class="simple">
<dt>In the folder structure above:</dt><dd><ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">ssp</span></code> is always the root of the output structure</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Agent0xxx</span></code>: the output is grouped by the agent who produced it (Agent0 -&gt; Agent0000, Agent1 -&gt; Agent0001)</p></li>
<li><p>the output is grouped by its producing System name</p></li>
<li><p>Further, the output is grouped by Components</p></li>
<li><p>There are two different possible output files: Json and BinaryTrace</p></li>
</ul>
</dd>
</dl>
<p>Json files for
- For every timestep a json file containing the connector’s OSI message will be created</p>
<p>BinaryTrace files for
- Serialized OSI message as string from a specified connector</p>
</section>
<section id="writemessageparameters">
<h3>WriteMessageParameters<a class="headerlink" href="#writemessageparameters" title="Link to this heading"></a></h3>
<p>We can specify for each component if json and/or binary traces are written to a file by using the parameter set
“WriteMessageParameters”. The following shows an example:</p>
<blockquote>
<div><div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">                            </span><span class="nt">&lt;ssv:ParameterSet</span><span class="w"> </span><span class="na">version=</span><span class="s">&quot;1.0&quot;</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;WriteMessageParameters&quot;</span><span class="nt">&gt;</span>
<span class="w">                                </span><span class="nt">&lt;ssv:Parameters&gt;</span>
<span class="w">                                    </span><span class="cm">&lt;!-- &lt;ssv:Parameter name=&quot;WriteJson_SensorData&quot;&gt;</span>
<span class="cm">                                        &lt;ssv:String value=&quot;OSMPSensorDataOut&quot;/&gt;</span>
<span class="cm">                                    &lt;/ssv:Parameter&gt;</span>
<span class="cm">									&lt;ssv:Parameter name=&quot;WriteTrace_SensorData&quot;&gt;</span>
<span class="cm">                                        &lt;ssv:String value=&quot;OSMPSensorDataOut&quot;/&gt;</span>
<span class="cm">                                    &lt;/ssv:Parameter&gt; --&gt;</span>
<span class="w">                                </span><span class="nt">&lt;/ssv:Parameters&gt;</span>
<span class="w">                            </span><span class="nt">&lt;/ssv:ParameterSet&gt;</span>
</pre></div>
</div>
</div></blockquote>
<p>How to read these parameters:
- WriteJson_SensorData: We write json outputs for the connector triple “OSMPSensorDataOut”
- WriteTrace_SensorData: We write binary traces for the connector triple “OSMPSensorDataOut”</p>
</section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="spawner_features.html" class="btn btn-neutral float-left" title="Spawner Features" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="world_osi.html" class="btn btn-neutral float-right" title="World_OSI" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>